/*------------------------------------------------------
	Library for Document Analysis System
	(Document Image Frame-buffer class)
		Written  by H.Goto, Feb. 1995
		Modified by H.Goto, Feb. 1997
		E-Mail: hgot@ecip.tohoku.ac.jp
------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1995-1997  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#ifndef	Docfb_h
#define	Docfb_h

#include	"ufilep.h"
#include	"siplib.h"


class DOCFB {
    private:
	int		xpad,ypad;
	int		bgcolor;
    public:
	SIPImage	*image;
	int		width0,height0;
	int		width ,height ;

	void		setpadding(int xpad,int ypad);
	void		setbgcolor(int bgcol){  bgcolor = bgcol;  }
	char		*getimgptr(int x,int y);
	int		load_file(char *fname,int noload,int transpose);
	int		load_file(char *fname,int noload){
				return( load_file(fname,noload,0) );
			};
			DOCFB();
			~DOCFB();
};


#endif	/* Docfb_h */
