.TH kiri 1 "Sept. 1997"
.SH NAME
kiri \- cuts over\-connections on text line candidates
.SH SYNOPSIS
.B kiri
.BR
[\-options]
.BR
.I str_file
.BR
\-limgdir 
.I str_image_dir
.BR
\-o 
.I out_str_file

.SH DESCRIPTION
kiri reads an outline file 
.I str_file
created by lnextr2(1), 
reads the string image files in 
.I str_image_dir,
cuts over\-connections on text line candidates
and writes new outline data on 
.I out_str_file.
The "over\-connection" is the point at which two independent text lines connect
each other accidentally.
Such a connection can often occur in multi\-column document.

.PP
The format of 
.I str_file
and that of 
.I out_str_file
are both tloutline(4).
The format of string image file is raw, binary pbm(5).
The string files are assumed to have been named "STRxxxx",
where "xxxx" denotes the serial number of image.

.PP
kiri can handle only horizontal text lines.
The skew angle of text line is limited to about \-7 to +7degs.
kiri can handle text lines with various skew angles in a same image.

.SH OPTIONS
.TP
.B \-help, \-h
Show a help message.
.TP
.B \-limgdir str_image_dir
Set the name of the subdirectory in which 
string image files are stored.
.TP
.B \-dpi N
Set the resolution of the original document image.
Only one of the integer 200(dpi) and 400(dpi) is acceptable for N.
See lnextr2(1) manual page for more information.


.SH EXIT STATUS
The following exit values are returned:
.PD 0
.TP 10
.B 0
Successful completion.
.TP
.B > 0
An error occurred.
.PD

.SH SEE ALSO
strextr(1), lnextr2(1), pbm(5), tloutline(4)

.SH NOTES
This program is just a SAMPLE, so that there may be some limitations or 
reductions.

.PP
This program was developed by Hitoshi TSUKATA and modified later by
Hideaki Goto.

E\-Mail: hgot@ecip.tohoku.ac.jp, hgot@aso.ecei.tohoku.ac.jp


.SH REFERENCES
The algorithm used in this program was appeared in 
the Japanese proceedings of a regional meeting held in
Tohoku district, Japan, in 1995.
The document has only Japanese title.
The translated title must be as following.

.PP
Hitoshi Tsukata, Hideaki Goto and Hirotomo Aso,
"A method for improving the precision of text line extraction in
multi\-column documents", 
1995 Tohoku\-section joint convention record of institutes electrical
and information engineers, Japan, 2I21, pp.371. 

.SH AUTHOR
Copyright (C) 1994\-1997 Hitoshi TSUKATA
.\" Permission to use, copy, modify, and distribute this software and
.\" its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notice and this permission
.\" notice appear in all copies and in supporting documentation, (ii)
.\" the name of the author, Hitoshi TSUKATA, may not be used in any
.\" advertising or otherwise to promote the sale, use or other
.\" dealings in this software without prior written authorization
.\" from the author, (iii) this software may not be used for
.\" commercial products without prior written permission from the
.\" author, and (iv) the notice of the modification is specified in
.\" case of that the modified copies of this software are distributed.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
.\" THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
.\" SOFTWARE.

E\-Mail: nng@aso.ecei.tohoku.ac.jp
