/*----------------------------------------------------------------------
    PBM File Input/Output
	Created  by H.TSUKATA  1995
        Modified by H.Goto     Sept. 1997
----------------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1995-1997  Hitoshi TSUKATA

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hitoshi TSUKATA, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/


#ifndef _PBM_FILE_H_
#define _PBM_FILE_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	pbm_quanti_width(x)	((((x)+7)/8)*8)

typedef	unsigned char	bit;

#ifdef	__cplusplus
extern "C" {
#endif

bit** pbm_allocarray(int cols,int rows);
void pbm_freearray(bit **t,int rows);

#ifdef	__cplusplus
}
#endif



class pbm_file { 
private:
  int	width;
  int	height;

public:
  bit	**bits;  
  pbm_file(void){	width = 0;	height = 0;	  }
  
  virtual ~pbm_file(void){
	if( width>0 && height>0)
	  pbm_freearray( bits, width);
  }
  void pbm_init(void);
//  void readpbm( FILE	*fp);
//  void writepbm( FILE *fp);
  int readpbm(char *fname);
  int writepbm(char *fname);
  void pbm_alloc( int w, int h);
  void pbm_free( void);
  void pbm_crop( pbm_file & n_img,int n_col, int n_row, int n_cols, int n_rows);
  int pbm_width( void){	return( width);}
  int pbm_height( void){ return( height);}
  int pbmprojection(int **prj, int flg);
  void pbmfold( int v);
};


#endif	/* _PBM_FILE_H_ */
