/*----------------------------------------------------------------------
    Miscellaneous functions and definitions for segmentation
        Created  by H.TSUKATA      1995
        Modified by H.Goto     Sep 1997
        Modified by H.Goto     Sep 2003
----------------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1995-2003  Hitoshi TSUKATA and Hideaki GOTO

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the names of the authors, Hitoshi TSUKATA and Hideaki Goto, may
  not be used in any advertising or otherwise to promote the sale,
  use or other dealings in this software without prior written
  authorization from the authors, (iii) this software may not be used
  for commercial products without prior written permission from the
  author, and (iv) the notice of modification is specified in cases
  where modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/


#ifndef _SEG_H_
#define _SEG_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "zenza.h"
#include "pbm_file.h"

#define SLIT_WIDTH 		(16)

#define	EMPTY_LABEL		(-1)
#define	EMPTY_TREE		(-1)
#define	EMPTY_RGN		(-1)

#define MAX_DIST				(DBL_MAX)


#define A4_HEIGHT		(2322)
#define A4_WIDTH		(1632)
#define MAX_LINE_IN_RGN_COUNTS 	(200)
#define MAX_LINE_COUNTS 		(800)

#define A			(.3)

typedef	double	LINEHEIGHT;
typedef	double	LINESLOPE;
typedef short	TREE_INDEX;

class d4pac	;
class Rectangle;
class STRING;
class TREE;
class RGN;

class TAREA	;
// class NODE;

class Document : public pbm_file {
private:
//  TAREA		*tarea;
//  int	area_num, area_num_x, area_num_y;
  //  int	area_width, area_height;
  
public:
  STRING	*line;
  int		line_num;
  RGN		*block;
  //TAREA		*hyou;
  
  int	readlinedata( FILE *fp);	
  void	writelinedata( FILE *fp);	

  void	readblockdata( FILE *fp);	
  void 	writeblockdata( FILE *fp);
  
  void makergn(void);
  void makeorder( void);

  void	mesh( int , int);
  TAREA	*xy2area( int , int );
  void	hyounuki( void);

  virtual ~Document(void){
	//	delete []line;
  }
};

#define RUN_TOP	(0) 		/***** ΤϤޤϡǤ *****/

#define seifu(i)	( (i)>0 ) - ( (i)<0 )	 	


/*
 *	  ѿ 
 */ 

/* ˵ʸԽ(nss) ط */
#define T3	1.5	/* θ³ */
#define T4	(5)	/* Υθ³ */
#define T5	(1.3)	/* ᥤΡɤȤι⤵θ³ */

/* Ƕܴطʸ(ns) ط */
#define T60	(1.3)	/* Ϥθ³ */
#define T61	(.8)	/* Ťʤ */

/*  ط */
#define T70	(.85)	/* Τ˴ؤ뤷 */
#define T71	(1.4)	/* Τ˴ؤ뤷 ͱ */
#define T72	(1.1)	/* Τ˴ؤ뤷 Ƚ */


/* ԡн ط */
#define T80	(high)	/* ԡФι⤵ˤ뤷 */

#define T100	(.35)	/* ң̣Ӥˤ뤷 */


/*
 *	  ѿ 
 */ 

/* ʸϥ֥åϢ */
#define TR010	(1.30)	// Υ å
//#define TR011	(.30)	// ʤ
#define TR011	(T61)	// ʤ
#define TR0112	( TR011*.1)	// ʤ
#define TR012	(T60)	// ()
#define TR0122	(T60*15)	// ()
//#define TR013	(T5)	// ⤵


/*
 *	ǥե
 */

#define HABA_DEFAULT	(12)
#define HIGH_DEFAULT	(24)
#define LINEIMAGEDIR_DEFAULT	"cuttmp/"
#define OUTFILE_DEFAULT		"kiri.line"
#define DPI_DEFAULT	(200)

#define OUTDIR_DEFAULT		"./rgntmp/"

struct d8pac {
  short           d8_data[8];
};

struct d8file {
  char            d8_magic[8];	/* = "DATA0008" */
  long            d8_attrb;	/* = 0 */
  long            d8_count;	/* = 0 */
  short           d8_llimit[8];	/* lower  limit of each data */
  short           d8_hlimit[8];	/* higher limit of each data */
  short           d8_spc[40];	/* (filler) */
};



struct lseginfo {
  short		x;				/* ʬ濴 x ɸ */
  short		y;				/* ʬ濴 y ɸ */
  short		a;				/* ʬη */
  short		htpeak;			/* Hough֤ˤԡ */
  short		corroff;		/* طΥԡ */
  short		corrpeak;		/* طΥԡ */
  short		dummy1;
  short		dummy2;
};

/* - - - - - - - - - -  Cut  Here  - - - - - - - - - - - - - - - - - - - -  */


class OPTION{
public:
  char		com[512];
  char		crfile[512];
  char		strfile[512];
  char		infile[512];
  char		outfile[512];
  char		imagefile[512];
  char		outdir[512];
  char		lsegfile[512];
  char		lsegVfile[512];
  char		mfile[512];
  char		rgnfile[512];

  double	rate;
  int		list_type;
  short	ps_flg;
  short	msg_flg	;
  char		lineimagedir[512];
  int		haba, high;
  int		printtree_flg;
  int		dpi;
  short 	info;
  TREE_INDEX	index_from;
  TREE_INDEX	index_to;
  int		v_flg;
  short 	geo;
  short 	simpleinfo;
  short		message_flg;
  char		outfile2[512];
  short		mesh_flg;
  short		hantei;
  short	debug_flg;
  int		remake_flg;

  OPTION( void){
	v_flg=0;
	debug_flg=0;
	outfile2[0]='\0';
	message_flg = 0;
	mesh_flg = 0;
	dpi = DPI_DEFAULT ;
	hantei = 0;
	printtree_flg = 0;
	ps_flg = 0;
	info = 0;
	simpleinfo = 0;
	geo = 0;
	remake_flg = 1;

	strcpy( crfile, "");
	strcpy( strfile, "");
	strcpy( infile, "");
	strcpy( outfile, "");
	strcpy( imagefile, "");
	strcpy( outdir, "");
	strcpy( lsegfile, "");
	strcpy( lsegVfile, "");
	strcpy( mfile, "");
	strcpy( rgnfile, "");
  }
};


class CONFACT{
public:
  double	fact_s;
  double	fact_l;
  double	fact_h;
  double	fact_g;

  double	fact_o;
  double	fact_d;


  //OLD
  //  double	fact_h;
  //double	fact_d;
  //  double	fact_g;
  double	fact_w;
  double	fact_kas;
  //OLD



  CONFACT(void){
	fact_s=0; fact_l=0; fact_h=0; fact_g=0; fact_o=0; fact_d=0;
  }



};      

class LSEG {
public:
  TREE_INDEX	index;
  int			x;	
  int			y;
  LINEHEIGHT 	h;
  int			w;
  double	cx;	/* (cx,cy);νſɸ  */
  double	cy;
  LINESLOPE	slope;	// DEG.
};


#endif /* _SEG_H_ */
