/*
    Imake template and rules for DAR-programs
        Written by H.Goto, July 2003
*/

/*--------------------------------------------------------------------
  Copyright (C) 1997-2003  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of modification is specified in cases
  where modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

/*--------------------------------
   Start of Configuration Part
--------------------------------*/

/*
    Set the destination path where bin/lib/include/man should go.

    Codes will be placed in the following directories.

	bin     ->   $(DESTDIR)/bin$(ARCH_SUBDIR)
	lib     ->   $(DESTDIR)/lib$(ARCH_SUBDIR)
	include ->   $(DESTDIR)/include$(ARCH_SUBDIR)
*/

DESTDIR = $(HOME)/O2/DARsys


/*
    Set subdirectory name of architecture with '/' on the head,
    if required.

        e.g.)  ARCH_SUBDIR = /sparc-sun-solaris9
*/

ARCH_SUBDIR =


/*
    Set install flags.
     (INSTBINFLAGS,INSTLIBFLAGS,INSTINCFLAGS,INSTMANFLAGS,INSTDATFLAGS)
*/

INSTBINFLAGS = -m 0755
INSTLIBFLAGS = -m 0644
INSTINCFLAGS = -m 0644
INSTMANFLAGS = -m 0644


/*
    Set byte order of processor. (-DMSB_FIRST or -DLSB_FIRST)
        MSB_FIRST:  SPARC, PPC, ... etc.
        LSB_FIRST:  x86, Alpha, IA64, ... etc.
*/

BYTEORDERDEF = -DMSB_FIRST


/*
    Set paths for user's header files.
*/

USR_INCLUDES = -I$(HOME)/O2/include$(ARCH_SUBDIR) -I$(HOME)/O2/DARsys/include$(ARCH_SUBDIR)


/*
    Set paths for user's libraries.
*/

USR_LIBRARIES = -L$(HOME)/O2/lib$(ARCH_SUBDIR) -L$(HOME)/O2/DARsys/lib$(ARCH_SUBDIR)


/*
    Set C and C++ compilers and compiler option(s).
*/

/* GNU C/C++, generic
CC = gcc
CXX = g++
CCOPTIONS = 
CDEBUGFLAGS = -O3
*/

/* GNU C/C++, Solaris (SPARC)
CC = gcc
CXX = g++
CCOPTIONS = -msupersparc
CDEBUGFLAGS = -O3
*/

/* Forte Developer 6 Compiler C/C++, Solaris (SPARC)
*/
CC = cc
CXX = CC
CCOPTIONS =
CDEBUGFLAGS = -xO3 -xarch=v9a

/* GNU C/C++, Tru64 UNIX (Alpha)
CC = gcc
CXX = g++
CCOPTIONS = -Wall
CDEBUGFLAGS = -O3 -mcpu=ev6
*/

/* Intel C/C++ Compiler, Linux (IA64)
CC = ecc
CXX = ecpc
CCOPTIONS = 
CDEBUGFLAGS = -O2
*/

/*--------------------------------
   End of Configuration Part
--------------------------------*/
