.TH strextr 1 "Aug. 1997"
.SH NAME
strextr \- extract images of text line from document image
.SH SYNOPSIS
.B strextr
.BR
[\-options]
.BR
.I str_file
.BR
[\-image 
.I image_file
]
.BR
[\-resdir 
.I result_dir
]
.BR
[\-o 
.I out_str_file
]

.SH DESCRIPTION
strextr reads an outline file 
.I str_file
created by lnextr2(1), reads 
document image
.I image_file
, extracts string images in text line and writes them on 
image files.
.PP
The file format of the outline file is tloutline(4), and 
that of the document image is raw, binary pbm(5).
The extracted string images in text line are written on individual files of 
raw, binary pbm(5) format.
The output files are named "STRxxxx", where "xxxx" denotes
the serial number of image, and put into the specified 
directory
.I result_dir
.
This directory must be created before running strextr.
The default directory for output is "./cuttmp".
.PP
The interpolator for text line data and image filter are also built\-in.

.SH OPTIONS
.TP
.B \-help, \-h
Show a help message.
.TP
.B \-dpi N
Set the resolution of the original document image.
Only one of the integer 200(dpi) and 400(dpi) is acceptable for N.
See lnextr2(1) manual page for more information.
.TP
.B \-trans
Assume the document image is transposed.
Horizontal\- and vertical\-axis are exchanged.
.TP
.B \-raw
Raw extraction mode.
If this mode is preferred, the images on inner region of each rectangle
(in outline file) will be copied to the output buffer as string image.
.TP
.B \-rect
Assuming that the text lines are almost completely horizontal to the axis of 
document image, strextr fit a single rectangle for each text line.
The inner image of the fitted rectangle will be copied to the output 
buffer as string image.
.TP
.B \-irect
Assume that the text lines have skew and that they are not bent or wavy.
strextr fit a single, inclined rectangle for each text line.
The inner image of the fitted rectangle will be copied to the output 
buffer as string image.
.TP
.B \-lrect
Assume that the text lines are bent or wavy.
strextr fits some inclined rectangles for each text line.
The inner image of the fitted rectangles will be copied to the output 
buffer as string image.
This option is default.
\-raw, \-rect, \-irect and \-lrect options are exclusive each other.
.TP
.B \-interp
Interpolate Primitive Rectangles.
.TP
.B \-filter
Apply image filter.
Extracted string image is checked whether it seems to be the real
string. If not so, the image will be discarded.
.TP
.B \-deskew
Estimate the skew of each string image and correct the arrangement of that.
.TP
.B \-nwr
Suppress writing string images on files.
This option is for debugging.
.TP
.B \-verbose, \-v 
Enable printing processing information simultaneously.


.SH EXIT STATUS
The following exit values are returned:
.PD 0
.TP 10
.B 0
Successful completion.
.TP
.B > 0
An error occurred.
.PD

.SH SEE ALSO
lnextr2(1), pbm(5), tloutline(4)

.SH NOTES
This program is just a SAMPLE, so that there may be some limitations or 
reductions.
.PP
The built\-in image filter has not yet been examined carefully.
The filter was designed and incorporated in order to
improve the overall processing time of the following process
such as character recognition.


.SH AUTHOR
Copyright (C) 1994\-1997 Hideaki Goto
.\" Permission to use, copy, modify, and distribute this software and
.\" its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notice and this permission
.\" notice appear in all copies and in supporting documentation, (ii)
.\" the name of the author, Hideaki Goto, may not be used in any
.\" advertising or otherwise to promote the sale, use or other
.\" dealings in this software without prior written authorization
.\" from the author, (iii) this software may not be used for
.\" commercial products without prior written permission from the
.\" author, and (iv) the notice of the modification is specified in
.\" case of that the modified copies of this software are distributed.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
.\" THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
.\" SOFTWARE.

E\-Mail: hgot@ecip.tohoku.ac.jp, hgot@aso.ecei.tohoku.ac.jp
